<template>
  <div>
    <mt-page-title
      :with-border="false"
      :with-padding="false"
      border-style="padding:1.5rem 0"
      link-text="retour au profil"
      :link-to="{ name: 'infos-persos' }"
    >
      <h1 class="has-text-weight-bold is-size-3">Modifier mon mot de passe</h1>
    </mt-page-title>

    <form @submit.prevent="savePassword()">
      <div class="columns">
        <div class="column">
          <b-field label="Ancien mot de passe">
            <b-input
              key="current"
              v-model="changePassword.passwordCourant"
              type="password"
              password-reveal
              required
              class="mt-input"
            />
          </b-field>

          <b-field label="Nouveau mot de passe">
            <b-input
              key="password"
              v-model="changePassword.password"
              type="password"
              password-reveal
              required
              class="mt-input"
            />
          </b-field>

          <b-field label="confirmez le Mot de passe">
            <b-input
              key="confirm"
              v-model="changePassword.passwordconfirmation"
              type="password"
              password-reveal
              required
              class="mt-input"
            />
            <div class="control">
              <p v-if="erreur" class="help is-danger">{{ erreur }}</p>
            </div>
          </b-field>
        </div>

        <div class="column column-with-margin">
          <mt-password-security-meter :password="changePassword.password" :rules="rules"></mt-password-security-meter>
        </div>
      </div>

      <div class="mt-margin-top">
        <b-button
          class="mt-button is-size-7 has-text-weight-semibold"
          type="is-primary"
          native-type="submit"
          :disabled="
            !changePassword.passwordCourant || !changePassword.password || !changePassword.passwordconfirmation
          "
        >
          Enregistrer
        </b-button>
      </div>
    </form>

    <mt-modal-ok :ouvert.sync="mtmodalokReussite" @action="retourInfosPersos">
      Votre mot de passe a bien été modifié.
    </mt-modal-ok>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtPasswordSecurityMeter from '~/components/connexion/password-security-meter';
import MtModalOk from '~/components/modal/mt-modal-ok';
import passwordRulesMixin from '~/components/mixins/passwordRulesMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtPasswordSecurityMeter,
    MtModalOk,
  },
  mixins: [passwordRulesMixin],
  data() {
    return {
      mtmodalokReussite: false,
      erreur: null,
      changePassword: {
        passwordCourant: null,
        password: null,
        passwordconfirmation: null,
      },
    };
  },

  methods: {
    async savePassword() {
      try {
        if (this.changePassword.password !== this.changePassword.passwordconfirmation) {
          this.erreur = 'Le nouveau mot de passe et sa confirmation doivent être identiques.';
        } else {
          this.erreur = '';
          await this.$api.utilisateurs.changementMotDePasseConnecter(this.changePassword);
          this.mtmodalokReussite = true;
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.toast.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    retourInfosPersos() {
      this.$router.push('/infos-persos');
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.field.has-addons {
  display: block;
}
.field.has-addons input {
  border-radius: $border-radius !important;
}
.column-with-margin {
  margin-left: 1rem;
}
.mt-margin-top {
  margin-top: 2rem;
}
</style>
